-- inverse.love for color reversal

function love.load()
	gr, ky, lf		= love.graphics, love.keyboard, love.filesystem
	gr.setFont( gr.newFont( 18 ) )
	images 			= lf.enumerate('images')
	select 			= 1
	gr.setCaption("color reversal effect")
	effect = love.graphics.newPixelEffect [[
	vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
		{
		vec4 pixel = Texel(texture, texture_coords);
		number t1 = pixel.r + pixel.g + pixel.b;	// original intensity
		number t2 = 3 - pixel.r - pixel.g - pixel.b;// inverse intensity
		number t3 = t1 / t2;						// adjust to original intensity
		pixel.r = t3 * ( 1 - pixel.r );
		pixel.g = t3 * ( 1 - pixel.g );
		pixel.b = t3 * ( 1 - pixel.b );
		return  pixel;
		}
		]]
	image	= gr.newImage('images/' .. images[ select ])
	--image	= gr.newImage('images/belice.jpg')--flower.png')--glass.png')
	show_effect = false
	end

function love.draw()
	if show_effect then
		gr.setPixelEffect(effect)
		gr.draw(image, 0, 0)
		gr.setPixelEffect()
		gr.print("inverse effect",10,10)
		else
		gr.draw(image,0,0)
		gr.print("no effect applied",10,10)
		end
	gr.print("press <e> to apply",10,30)
	gr.print('press <s> to change image', 10,50)
	gr.print( 'fps: '..love.timer.getFPS( ), 650, 550 )
	end

function love.keypressed( key )  -- one operation per key press
	if key == 'escape'	then love.event.push( 'quit' )	end
	if key == 'e' then show_effect = not show_effect end
	if key == 's' then
		select=select<#images and select + 1 or 1
		image	= gr.newImage('images/' .. images[ select ])
		end
	end

